import java.util.concurrent.CountDownLatch;
import java.util.Random;

public class Worker implements Runnable {

   private final CountDownLatch startSignal;
   private final CountDownLatch doneSignal;
   private final int id;

   private final Random r = new Random();
   private final String format_1 = "Worker %d sleeping for %f seconds";
   private final String format_2 = "Worker %d finished sleeping.";

   public Worker(CountDownLatch startSignal,
                 CountDownLatch doneSignal,
                 int id) {
      this.startSignal = startSignal;
      this.doneSignal = doneSignal;
      this.id = id;
   }

   private void doWork() {
     int sleep = r.nextInt(5000);
     System.out.println(String.format(format_1, id, sleep/1000.0));
     try {
       Thread.sleep(sleep);
     } catch (Exception ex) {
     }
     System.out.println(String.format(format_2, id));
   }

   public void run() {
      try {
        startSignal.await();
        doWork();
        doneSignal.countDown();
      } catch (InterruptedException ex) {} // return;
   }

}
