import java.util.LinkedList;
import java.util.List;
import java.util.Random;

public class Main {

  private final List<Account>  accounts  = new LinkedList<Account>();
  private final List<Thread> customers = new LinkedList<Thread>();
  private final Random         r         = new Random();

  public Main() {
    for (int i = 0; i < 20; i++) {
      accounts.add(new Account(r.nextInt(10000)));
    }
    for (int i = 0; i < 10; i++) {
      customers.add(new Thread(new Customer(accounts, i)));
    }
  }

  public void run() {
    int index = 0;
    for (Account a : accounts) {
      System.out.println("Account[" + index + "]: " + a.getBalance()); 
      index++;
    }

    for (Thread t : customers) {
      t.start();
    }

    for (Thread t : customers) {
      try {
        t.join();
      } catch (Exception ex) {
      }
    }

    index = 0;
    for (Account a : accounts) {
      System.out.println("Account[" + index + "]: " + a.getBalance()); 
      index++;
    }

  }

  public static void main(String[] args) {
    Main m = new Main();
    m.run();
  }

}
